import { ComponentInternalInstance, ObjectDirective } from 'vue';
import { EventsBackboneEventHandler, EventsBackboneSpineEntryOption, EventsBackboneDirectiveParams, EventsBackboneSpineInterface } from '../types';
export interface EventsBackboneSpineConstructor {
    new (): EventsBackboneSpine;
}
export declare class EventsBackboneSpine implements EventsBackboneSpineInterface {
    private readonly spine;
    private readonly _internalComponentInstances;
    private readonly _componentInstancesHandlerOpts;
    constructor();
    checkKeys(obj: any): number;
    private _normalizeHandlerName;
    private _callHandler;
    private _internalEmitGlobalEvent;
    private _internalEmitEvent;
    emitEvent(currentInstance: ComponentInternalInstance, ev: string, data?: any, global?: boolean): Promise<void>;
    private _getEventHandlerOpts;
    private _addHandlerOptions;
    private _removeHandlerOptions;
    private _removeAllEventOptions;
    private _removeAllHandlerOptions;
    private _registerComponentInstance;
    private _unregisterComponentInstance;
    on(componentInstance: ComponentInternalInstance, ev: string, h: EventsBackboneEventHandler, opts?: EventsBackboneSpineEntryOption): void;
    off(uid: number, ev: string, h?: EventsBackboneEventHandler): void;
    offAll(uid: number): void;
}
export declare const BB: EventsBackboneSpine;
export declare const EventsBackBoneDirective: ObjectDirective<any, EventsBackboneDirectiveParams>;
